﻿using DemoApplication.ModelView;
using Microsoft.Build.Tasks.Deployment.Bootstrapper;
using Microsoft.Office.Interop.Excel;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Excel = Microsoft.Office.Interop.Excel;
using Page = System.Windows.Controls.Page;


namespace ProjectAnalogParus
{
    /// <summary>
    /// Логика взаимодействия для AccrualsPage.xaml
    /// </summary>
    public partial class AccrualsPage : Page
    {
        gr672_bdaEntities db = new gr672_bdaEntities();
        public AccrualsPage()
        {
            InitializeComponent();
        }      

        private void ExcelClick(object sender, RoutedEventArgs e)
        {          
            Excel.Application excel = new Excel.Application();
            excel.Visible = true;
            Workbook workbook = excel.Workbooks.Add(System.Reflection.Missing.Value);
            Worksheet sheet1 = (Worksheet)workbook.Sheets[1];
            for (int j = 0; j < FilterDataGrid.Columns.Count; j++)
            {
                Range myRange = (Range)sheet1.Cells[1, j + 1];
                sheet1.Cells[1, j + 1].Font.Bold = true;
                sheet1.Columns[j + 1].ColumnWidth = 15;
                myRange.Value2 = FilterDataGrid.Columns[j].Header;
            }
            for (int i = 0; i < FilterDataGrid.Columns.Count; i++)
            {
                for (int j = 0; j < FilterDataGrid.Items.Count; j++)
                {
                    TextBlock b = FilterDataGrid.Columns[i].GetCellContent(FilterDataGrid.Items[j]) as TextBlock;
                    Microsoft.Office.Interop.Excel.Range myRange = (Microsoft.Office.Interop.Excel.Range)sheet1.Cells[j + 2, i + 1];
                    myRange.Value2 = b.Text;
                }
            }
        }
        
        private void LoadedWindows(object sender, RoutedEventArgs e)
        {
            FilterDataGrid.ItemsSource = db.AccrualsScholarship.ToList();
        }

        public void ShowAcctuals()
        {
            FilterDataGrid.ItemsSource = db.AccrualsScholarship.Where(item => 
            (item.Student.LastName + " " + item.Student.FirstName + " " + 
            item.Student.Middlename + " " + item.User.FullNameUser + " " + 
            item.Scholarship.NameScholarship + " " + 
            item.Encouragement.NameTypeEncouragement + " " + item.Amount + " " + 
            item.DateAccruals + " ").Contains(TxtSearch.Text)).ToList();
        }

        private void TxtSearch_TextChanged(object sender, TextChangedEventArgs e)
        {
            ShowAcctuals();
        }
    }
}
