﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ProjectAnalogParus
{
    /// <summary>
    /// Логика взаимодействия для EncouragementSummaPage.xaml
    /// </summary>
    public partial class EncouragementSummaPage : Page
    {
        gr672_bdaEntities db = new gr672_bdaEntities();
    
        public EncouragementSummaPage()
        {
            InitializeComponent();

            cmbStudent.ItemsSource = db.Student.ToList();         
            cmbStudent.SelectedValuePath = "IdStudent";

            cmbScholarship.ItemsSource = db.Scholarship.ToList();
            cmbScholarship.DisplayMemberPath = "NameScholarship";

            cmbUser.ItemsSource = db.User.ToList();
            cmbUser.DisplayMemberPath = "FullNameUser";
            cmbUser.SelectedValuePath = "IdUser";

            cmbEncoragement.ItemsSource = db.Encouragement.ToList();           

            cmbEncoragement.DisplayMemberPath = "NameTypeEncouragement";


            cmbScholarship.SelectedValuePath = "Amount";
            cmbEncoragement.SelectedValuePath = "Amount";

        }        

        private void SummaClick(object sender, RoutedEventArgs e)
        {

           
            if (cmbStudent != null && cmbUser != null && datetime != null || cmbScholarship != null || cmbEncoragement != null)
            {
               
                double ship = Convert.ToDouble(cmbScholarship.SelectedValue);
                double enco = Convert.ToDouble(cmbEncoragement.SelectedValue);

                double summ = ship + enco;
                AmoutSumma.Text = Convert.ToString(summ);
            }
            else
            {
                MessageBox.Show("Не все поля заполнены");
            }            

        }

        private void ReqisitesScholarshipsClick(object sender, RoutedEventArgs e)
        {
            if (cmbStudent != null && cmbUser != null && datetime != null || cmbScholarship != null || cmbEncoragement != null && AmoutSumma.Text != "")
            {               
                AccrualsScholarship accruals = new AccrualsScholarship();
                accruals.StudentId = Convert.ToInt32(cmbStudent.SelectedValue.ToString());
                accruals.UserId = Convert.ToInt32(cmbUser.SelectedValue.ToString());
                accruals.DateAccruals = Convert.ToDateTime(datetime.SelectedDate.ToString());
                accruals.ScholarshipId = Convert.ToInt32((cmbScholarship.SelectedItem as Scholarship).IdScholarship);
                accruals.EncouragementId = Convert.ToInt32((cmbEncoragement.SelectedItem as Encouragement).IdEncouragement);
                accruals.Amount = Convert.ToDecimal(AmoutSumma.Text);
                db.AccrualsScholarship.Add(accruals);
                db.SaveChanges();
                MessageBox.Show("Стипендия начислена студенту!");

            }
            else
            {
                MessageBox.Show("Не все поля заполнены!");
            }

        }   


    }
}
